//+------------------------------------------------------------------+
//|                                      Exp_JBrainSig1_UltraRSI.mq5 |
//|                             Copyright  2012,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"
//+-----------------------------------------------+
//|    CXMA                         |
//+-----------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+-----------------------------------------------+
//|                         |
//+-----------------------------------------------+
enum AlgMode
  {
   JBrainSig1Filter,// JBrainSig1,  UltraRSI
   UltraRSIFilter,  // UltraRSI,  JBrainSig1
   Composition      // 
  };
//+-----------------------------------------------+
//|                         |
//+-----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------------------+
//|             |
//+-----------------------------------------------+
input double MM=-0.1;             //      ,   -  
input int    StopLoss_=1000;      //  
input int    TakeProfit_=2000;    //  
input int    Deviation_=10;       //.    
input bool   BuyPosOpen=true;     //    
input bool   SellPosOpen=true;    //    
input bool   BuyPosClose=true;     //    
input bool   SellPosClose=true;    //    
input AlgMode Mode=Composition;    //    
//+-----------------------------------------------+
//|                 |
//+-----------------------------------------------+
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_H4; // 
input uint SignalBar=1;//     

//+-----------------------------------------------+
//|    JBrainTrendSig1  |
//+-----------------------------------------------+
input int ATR_Period=7; // ATR 
input int STO_Period=9; // 
input ENUM_MA_METHOD XMA_Method=MODE_SMA; // 
input ENUM_STO_PRICE STO_Price=STO_LOWHIGH; //  
input int XLength=7; //  JMA                    
input int XPhase=100; //  JMA ,
                      //   -100 ... +100,
//    ;
//+-----------------------------------------------+
//|    UltraRSI         |
//+-----------------------------------------------+
input int RSI_Period=13; //  RSI
input ENUM_APPLIED_PRICE Applied_price=PRICE_CLOSE; // 
//----
input Smooth_Method W_Method=MODE_JJMA; // 
input int StartLength=3; //                      
input int WPhase=100; // ,
                      // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//----  
input uint nStep=5; //  
input uint nStepsTotal=10; //  
//----
input Smooth_Method SmoothMethod=MODE_JJMA; // 
input int SmoothLength=3; //                     
input int SmoothPhase=100; // ,
                           // JJMA    -100 ... +100,     ; 
//+-----------------------------------------------+
//----          
int TimeShiftSec;
//----      
int InpInd1_Handle,InpInd2_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----    JBrainTrend1Sig
   InpInd1_Handle=iCustom(Symbol(),InpInd_Timeframe,"JBrainTrend1Sig",ATR_Period,STO_Period,XMA_Method,STO_Price,XLength,XPhase);
   if(InpInd1_Handle==INVALID_HANDLE) Print("     JBrainTrend1Sig");

//----    UltraRSI
   InpInd2_Handle=iCustom(Symbol(),InpInd_Timeframe,"UltraRSI",RSI_Period,Applied_price,W_Method,
                          StartLength,WPhase,nStep,nStepsTotal,SmoothMethod,SmoothLength,SmoothPhase,50,50,clrBlue,clrBlue,1,1);
   if(InpInd2_Handle==INVALID_HANDLE) Print("     UltraRSI");

//----          
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);

//----     
   int min_rates_1=int(MathMax(MathMax(ATR_Period,STO_Period),30)+2);

//----     
   CXMA XMA;
   int min_rates_2=RSI_Period;
   min_rates_2+=XMA.GetStartBars(W_Method,StartLength+nStep*nStepsTotal,WPhase)+1;
   min_rates_2+=XMA.GetStartBars(SmoothMethod,SmoothLength,SmoothPhase);
   min_rates_total=int(MathMax(min_rates_1,min_rates_2)+3+SignalBar);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----
   GlobalVariableDel_(Symbol());
//----
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//----       
   if(BarsCalculated(InpInd1_Handle)<min_rates_total || BarsCalculated(InpInd2_Handle)<min_rates_total) return;

//----       IsNewBar()  SeriesInfoInteger()  
   LoadHistory(TimeCurrent()-PeriodSeconds(InpInd_Timeframe)-1,Symbol(),InpInd_Timeframe);

//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;
   static CIsNewBar NB;

//+-----------------------------------------------+
//|                   |
//+-----------------------------------------------+
   if(!SignalBar || NB.IsNewBar(Symbol(),InpInd_Timeframe) || Recount) //     
     {
      //----   
      double UpVal1[1],DnVal1[1];
      double UpVal2[2],DnVal2[2];
      bool BUY_Open1,SELL_Open1,BUY_Open2,SELL_Open2;
      bool BUY_Close1,SELL_Close1,BUY_Close2,SELL_Close2;

      //----   
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;

      BUY_Open1=false;
      SELL_Open1=false;
      BUY_Close1=false;
      SELL_Close1=false;

      BUY_Open2=false;
      SELL_Open2=false;
      BUY_Close2=false;
      SELL_Close2=false;

      Recount=false;

      //----      JBrainTrendSig1
      int Bars_=Bars(Symbol(),InpInd_Timeframe);

      for(int bar=int(SignalBar); bar<Bars_; bar++)
        {
         if(CopyBuffer(InpInd1_Handle,0,bar,1,DnVal1)<=0) {Recount=true; return;}
         if(CopyBuffer(InpInd1_Handle,1,bar,1,UpVal1)<=0) {Recount=true; return;}

         if(DnVal1[0])
           {
            BUY_Close1=true;
            if(bar==int(SignalBar)) SELL_Open1=true;
            break;
           }

         if(UpVal1[0])
           {
            SELL_Close1=true;
            if(bar==int(SignalBar)) BUY_Open1=true;
            break;
           }
        }

      //----      
      if(CopyBuffer(InpInd2_Handle,0,SignalBar,2,UpVal2)<=0) {Recount=true; return;}
      if(CopyBuffer(InpInd2_Handle,1,SignalBar,2,DnVal2)<=0) {Recount=true; return;}

      //----    
      if(UpVal2[1]>DnVal2[1])
        {
         if(UpVal2[0]<=DnVal2[0]) BUY_Open2=true;
         SELL_Close2=true;
         UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }

      //----    
      if(DnVal2[1]>UpVal2[1])
        {
         if(DnVal2[0]<=UpVal2[0]) SELL_Open2=true;
         BUY_Close2=true;
         DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }

      switch(Mode)
        {
         case JBrainSig1Filter:
            if(BuyPosOpen&&BUY_Open2&&SELL_Close1) BUY_Open=true;
            if(SellPosOpen&&SELL_Open2&&BUY_Close1) SELL_Open=true;
            break;

         case UltraRSIFilter:
            if(BuyPosOpen&&BUY_Open1&&SELL_Close2) BUY_Open=true;
            if(SellPosOpen&&SELL_Open1&&BUY_Close2) SELL_Open=true;
            break;

         case Composition:
            if(BuyPosOpen&&(BUY_Open1&&SELL_Close2 || BUY_Open2&&SELL_Close1)) BUY_Open=true;
            if(SellPosOpen&&(SELL_Open1&&BUY_Close2||SELL_Open2&&BUY_Close1)) SELL_Open=true;
            break;
        }

      if(SellPosClose && SELL_Close1 && SELL_Close2) SELL_Close=true;
      if(BuyPosClose  &&  BUY_Close1  &&  BUY_Close2) BUY_Close=true;
     }

//+-----------------------------------------------+
//|                               |
//+-----------------------------------------------+
//----  
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);

//----     
   SellPositionClose(SELL_Close,Symbol(),Deviation_);

//----  
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);

//----  
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,MM,0,Deviation_,StopLoss_,TakeProfit_);
//----
  }
//+------------------------------------------------------------------+
